Skip to content

Latest commit

 

History

History
57 lines (44 loc) · 1.79 KB

27. Remove element.md

File metadata and controls

57 lines (44 loc) · 1.79 KB

Task

Given an integer array nums and an integer val, remove all occurrences of val in nums in-place. The order of the elements may be changed. Then return the number of elements in nums which are not equal to val.

Consider the number of elements in nums which are not equal to val be k, to get accepted, you need to do the following things:

  • Change the array nums such that the first k elements of nums contain the elements which are not equal to val. The remaining elements of nums are not important as well as the size of nums.
  • Return k.

Example 1: Input: nums = [3,2,2,3], val = 3 Output: 2, nums = [2,2,,] Explanation: Your function should return k = 2, with the first two elements of nums being 2. It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2: Input: nums = [0,1,2,2,3,0,4,2], val = 2 Output: 5, nums = [0,1,4,0,3,,,_] Explanation: Your function should return k = 5, with the first five elements of nums containing 0, 0, 1, 3, and 4. Note that the five elements can be returned in any order. It does not matter what you leave beyond the returned k (hence they are underscores).

Constraints:

  • 0 <= nums.length <= 100
  • 0 <= nums[i] <= 50
  • 0 <= val <= 100

Algorithm

  1. two pointers:
    • i - current element
    • j - place for next num != val
  2. iterate by nums
  3. find next num != val
  4. nums[j] = nums[i]
  5. j++

Code

int removeElement(vector<int>& nums, int val) 
{
	std::size_t j = 0;
	
	for(std::size_t i = 0; i < nums.size(); i++)
		if(nums[i] != val)
			nums[j++] = nums[i];
	
	return j;

}

#cs #cpp #leetcode #two_pointers